<html>
<head>
<title>Register for Password Mail Service</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<style>
body {
    color: #333333;
    font-family: Tahoma, Geneva, sans-serif;
}
.error {
    color: #FF0000;
    font-size: small;
}
</style>
</head>
<body>
<p>Register for Password Mail Service</p>
<?php
session_start();
//config start
$wspmsMailbox = "passwordservice@mycompany.com";
$forbiddenDomains = array("mycompany.com");
//config end
$mailError = $codeError = $captchaError = "";
$mail = $code = $captchaValidation = "";

function filterInput($input) {
    $input = trim($input);
    $input = stripslashes($input);
    $input = htmlspecialchars($input);
    return $input;
}

function validateInput() {
    global $forbiddenDomains;
    global $mailError, $codeError, $captchaError;
    global $mail, $code, $captchaValidation;
    $result = FALSE;
    if (!empty($_POST) | !empty($_GET)) {
        $result = TRUE;
        // Captcha check
        $captchaValidation = filterInput($_POST["captchaValidation"]);
        if (empty($captchaValidation)) {
            $captchaError = "Enter the captcha-code shown in the image below<br>";
            $result = FALSE;
        } elseif ($captchaValidation != $_SESSION["captchaCode"]) {
            $captchaError = "Incorrect captcha-code<br>";
            $result = FALSE;
        }
        // E-mail check
        $mail = filterInput($_REQUEST["mail"]);
        if (!filter_var($mail, FILTER_VALIDATE_EMAIL)) {
            $result = FALSE;
            $mailError = "Invalid e-mail address<br>";
        } else {
            $foundForbidden = "";
            foreach ($forbiddenDomains as $forbidden) {
                if (stripos($mail, "@" . $forbidden)) {
                    $foundForbidden = $forbidden;
                }
            }
            if ($foundForbidden != "") {
                $result = FALSE;
                $mailError = "The domain " . $foundForbidden . " is not allowed for registration<br>";
            }
        }
        // Code check, must be exactly 8 letters/digits long
        $code = filterInput($_REQUEST["code"]);
        if (empty($code) | !preg_match("/^[a-zA-Z0-9]{8}$/", $code)) {
            $result = FALSE;
            $codeError = "Enter your unique registration code<br>";
        } 
    }
    return $result;
}

if (validateInput()) {
    //  Input OK, send mail
    $headers = 'X-Mailer: PHP/' . phpversion();
     mail($wspmsMailbox, "register " . $code . " mail " . $mail . " ip " . $_SERVER['REMOTE_ADDR'], "User with e-mail address " . $mail . " registered for WSPMS at " . date("Y-m-d H:i"), $headers);
    // Thank you note
    ?>
<p>Thank you for your registration. You will receive a confirmation in your mailbox soon.</p>
    <?php
} else {
    // Display form
   ?>
<form action="<?php echo($_SERVER["PHP_SELF"]);?>" method="POST">
<table>
    <tr><td align="right" valign="bottom">Your e-mail address:</td><td><span class="error"><?php echo $mailError; ?></span><input type="text" name="mail" value="<?php echo $mail; ?>"></td></tr>
    <tr><td align="right" valign="bottom">Registration code:</td><td><span class="error"><?php echo $codeError; ?></span><input type="text" name="code" value="<?php echo $code; ?>"></td></tr>
    <tr><td align="right" valign="bottom">Captcha number:</td><td><span class="error"><?php echo $captchaError; ?></span><input type="text" name="captchaValidation"></td></tr>
    <tr><td></td><td align="left"><img src="captcha.php"></td></tr>
    <tr><td></td><td align="left"><input type="submit" name="action" value="Submit"></td></tr>
</table>
</form>
    <?php
}
?>
</body>
</html>
